package com.banesco.module.payment_file.infrastructure.client;

import com.banesco.common.application.helper.SerializationHelper;
import com.banesco.common.application.usecase.HttpClientUseCase;
import com.banesco.common.domain.exception.HttpStatusCodeException;
import com.banesco.common.domain.exception.ApiPrivateException;
import com.banesco.common.domain.model.*;
import com.banesco.common.infrastructure.config.RestClientConfig;
import com.banesco.module.payment_file.application.usecase.PaymentFileUseCase;
import com.banesco.module.payment_file.domain.dto.request.PaymentFileRequest;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.inject.Inject;
import lombok.extern.slf4j.Slf4j;

import java.util.Map;

@Slf4j
@ApplicationScoped
public class PaymentFileClient implements PaymentFileUseCase {
    private final SerializationHelper serializationHelper;
    private final HttpClientUseCase httpClientUseCase;
    private final PaymentFileConfig paymentFileConfig;

    private static final String EMPTY_MESSAGE = "EMPTY_MESSAGE";

    @Inject
    public PaymentFileClient(
        SerializationHelper serializationHelper,
        HttpClientUseCase httpClientUseCase,
        RestClientConfig restClientConfig
    ) {
        this.serializationHelper = serializationHelper;
        this.httpClientUseCase = httpClientUseCase;
        this.paymentFileConfig = restClientConfig.getPaymentFileConfig();
        log.info("Configuracion cargada para docservice-file: {}", paymentFileConfig);
    }

    @Override
    public <T> T execute(
        PaymentFileRequest params,
        Class<T> responseType
    ) {
        String fintechId = params.getFintechId();
        String fileName = params.getOperation().getName();
        Map<String, Object> payload = getPayload(params);
        HttpRequest request = HttpRequest.forApiPrivateResponse(
                paymentFileConfig.getUrl(),
                paymentFileConfig.getStatusSuccess(),
                HttpRequest.HttpMethod.POST,
                responseType
            )
            .withBody(payload)
            .withHeaders(Map.of("fintechId", fintechId))
            .withTimeout(
                paymentFileConfig.getTimeout().getConnect(),
                paymentFileConfig.getTimeout().getResponse()
            );

        try {
            ApiPrivateResponse<Either<T, ApiPrivateError>> response =
                httpClientUseCase.executeApiPrivateResponse(request);
            Either<T, ApiPrivateError> detail = response.getDetalle();

            if(detail == null) {
                log.error(
                    "API retorno exitoso pero con detalle vacio. Codigo: {}, Mensaje: {}",
                    response.getEstatus(),
                    response.getMensaje()
                );

                throw ApiPrivateException.builder()
                    .statusCode("PIBE-00")
                    .message(EMPTY_MESSAGE)
                    .build();
            }

            if (detail.isLeft()) {
                if(detail.getLeft() == null) {
                    throw ApiPrivateException.builder()
                        .statusCode("PIBE-00")
                        .message(EMPTY_MESSAGE)
                        .build();
                }
                
                return detail.getLeft();
            }

            ApiPrivateError error = detail.getRight();

            log.error(
                "API privada retorno error. Codigo: {}, Mensaje: {}, Error Interno: {} -> {}",
                response.getEstatus(),
                response.getMensaje(),
                error.getCodError(),
                error.getMensajeError()
            );

            throw ApiPrivateException.builder()
                .statusCode("PIBE-01")
                .message((error.getCodError() != null)
                    ? error.getCodError() + ":" + error.getMensajeError()
                    : EMPTY_MESSAGE
                )
                .build();
        } catch (ApiPrivateException e) {
            throw e;
        } catch (HttpStatusCodeException e) {
            log.error(
                "Error HTTP reportando el archivo {}: {} - {}",
                fileName,
                e.getStatusCode(),
                e.getMessage()
            );
            throw e;
        } catch (Exception e) {
            log.error("Error reportando el archivo {}: {}", fileName, e.getMessage());
            throw HttpStatusCodeException.serviceUnavailable("503");
        }
    }

    private Map<String, Object> getPayload(PaymentFileRequest params) {
        Map<String, Object> paymentFileRequest = serializationHelper.toMap(params);
        Map<String, Object> operation = serializationHelper.toMap(params.getOperation());
        String signature = serializationHelper.generateSignature(
            params.getOperation(), params.getChannelOrigin()
        );

        paymentFileRequest.put("signature", signature);
        paymentFileRequest.put("operation", operation);

        paymentFileRequest.remove("fintechId");

        log.info("3. Firma generada: {}", signature);
        log.info("4. Parametros de la solicitud: {}", paymentFileRequest);
        log.info("5. Solicitud final: {}", paymentFileRequest);

        return paymentFileRequest;
    }
}